--
-- Radium55
--
-- @author  Stefan Geiger
-- @date  08/12/10
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

Radium55 = {};

function Radium55.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function Radium55:load(xmlFile)

    self.tipRotationNodes = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.tipRotationNodes.tipRotationNode(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local rotSpeed = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, key.."#rotSpeed"), 1)*0.001);
        if node ~= nil then
            table.insert(self.tipRotationNodes, {node=node, rotSpeed=rotSpeed});
        end;
        i = i + 1;
    end;
end;

function Radium55:delete()
end;

function Radium55:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Radium55:keyEvent(unicode, sym, modifier, isDown)
end;

function Radium55:readStream(streamId, connection)
end;

function Radium55:writeStream(streamId, connection)
end;

function Radium55:readUpdateStream(streamId, timestamp, connection)
end;

function Radium55:writeUpdateStream(streamId, connection, dirtyMask)
end;

function Radium55:update(dt)
    if self.tipState ~= Trailer.TIPSTATE_CLOSED then
        for _, node in pairs(self.tipRotationNodes) do
            rotate(node.node, -dt*node.rotSpeed, 0, 0);
        end;
    end;
end;

function Radium55:updateTick(dt)
end;

function Radium55:draw()
end;
